package com.ruoyi.system.mapper;

import com.ruoyi.system.domain.EpsServerRevenueConfig;
import org.springframework.data.repository.query.Param;

import java.util.List;
import java.util.Map;

/**
 * 服务器收益方式配置Mapper接口
 * 
 * @author gyt
 * @date 2025-08-19
 */
public interface EpsServerRevenueConfigMapper 
{
    /**
     * 查询服务器收益方式配置
     * 
     * @param id 服务器收益方式配置主键
     * @return 服务器收益方式配置
     */
    public EpsServerRevenueConfig selectEpsServerRevenueConfigById(Long id);

    /**
     * 查询服务器收益方式配置列表
     * 
     * @param epsServerRevenueConfig 服务器收益方式配置
     * @return 服务器收益方式配置集合
     */
    public List<EpsServerRevenueConfig> selectEpsServerRevenueConfigList(EpsServerRevenueConfig epsServerRevenueConfig);

    /**
     * 新增服务器收益方式配置
     * 
     * @param epsServerRevenueConfig 服务器收益方式配置
     * @return 结果
     */
    public int insertEpsServerRevenueConfig(EpsServerRevenueConfig epsServerRevenueConfig);

    /**
     * 修改服务器收益方式配置
     * 
     * @param epsServerRevenueConfig 服务器收益方式配置
     * @return 结果
     */
    public int updateEpsServerRevenueConfig(EpsServerRevenueConfig epsServerRevenueConfig);

    /**
     * 删除服务器收益方式配置
     * 
     * @param id 服务器收益方式配置主键
     * @return 结果
     */
    public int deleteEpsServerRevenueConfigById(Long id);

    /**
     * 批量删除服务器收益方式配置
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEpsServerRevenueConfigByIds(Long[] ids);

    /**
     * 查询该数据是否存在
     *
     * @param hardwareSn 服务器sn
     * @return 数据条数
     */
    public EpsServerRevenueConfig countBySn(@Param("hardwareSn") String hardwareSn);

    /**
     * 查询服务器信息
     *
     * @param ipAddress ipv4地址
     * @return 服务器收益方式配置
     */
    public Map getNodeMsgByIp(@Param("ipAddress") String ipAddress);
    /**
     * 根据sn查询服务器信息
     *
     * @param hardwareSn 硬件SN
     * @return 服务器收益方式配置
     */
    public Map getNodeMsgBySn(@Param("hardwareSn") String hardwareSn);

    int updateEpsServerRevenueConfigByServerSn(EpsServerRevenueConfig epsServerRevenueConfig);

    /**
     * 当前在线服务器的流量相关的业务数
     * @return
     */
    Integer countBusinessByTraffic();

    /**
     * 当日业务的在线设备数量统计TOP5
     * @return
     */
    List<Map> countDeviceNumTop5();
}
